// computer_player.as

if (Object.Swim == null) {
	Object.Swim = {};
}

if (Object.Swim.ComputerPlayer == null) {
	Object.Swim.ComputerPlayer = {};
}

var ComputerPlayer = Object.Swim.ComputerPlayer;

Object.Swim.ComputerPlayer.initComputerPlayer = function (id, maxCards, chances, showMe, playerName) {
	findProto(Object.Swim.ComputerPlayer).implement (Object.Swim.Player);
	this.initPlayer (id, maxCards, chances, showMe, playerName);
	
	this.playerProto = findProto(Object.Swim.Player);
	
	this.delayTime = 2000;
	
	this.gotoAndStop("off");
} // initComputerPlayer

ComputerPlayer.think = function () {
	var stack = _parent.stack;
	stack.analyzeHand();
	
	var stackScore = stack.getScore();
	var stackCards = stack.getAllCards();
	var myCards = this.getAllCards ();
	var myScore = this.getScore();
	
	var stackSlot, changeSlot, mySlot;
	var stackCard;
	var anCards, anScore;
	
	var hiStackSlot, hiChangeSlot;
	var hiScore = myScore;
	
	// find the highest possible hand by trying the cards
	// from the stack in all positions
	for (stackSlot = 0; stackSlot<this.maxCards; stackSlot++ ) {
		stackCard = stackCards[stackSlot];
		
		for (changeSlot = 0; changeSlot < this.maxCards; changeSlot++) {
			anCards = [];
			
			for (mySlot = 0; mySlot < this.maxCards; mySlot++) {
				mySlot != changeSlot ?
					anCards[mySlot] = myCards[mySlot] :
					anCards[mySlot] = stackCard;
			}
			analyzeHand (anCards);
			if (this.getScore() > hiScore) {
				hiStackSlot = stackSlot;
				hiChangeSlot = changeSlot;
				hiScore = this.getScore();
			}
		}
	}
	
	if (hiScore > myScore || stackScore > myScore) {
		// go for the highest possible score
		if (hiScore > stackScore) {
			this.takeOne (hiChangeSlot, hiStackSlot);
		} else {
			this.takeAll ();
		}
	} 
	else {
		var knocking = false;
		// decide on whether to knock or not
		if (!this.firstTurn && _parent.getKnockPlayer == null && myScore >= 27) {
			var rnd = Math.floor (Math.random() * 3);
			if (rnd < 1) {
				knocking = true;
			}	
		}
		
		knocking ?
			this.knock() :
			this.pass();	
	}
	this.analyzeHand();
}

ComputerPlayer.yourTurn = function (lastMoves) {
	this._yourTurn = this.playerProto.yourTurn;
	this._yourTurn ( lastMoves );
	delete this._yourTurn;
	
	this.opening.show();
	
	this.show();
	this.hideHand();
	
	this.think();
}// yourTurn

ComputerPlayer.endOfTurn = function () {
	this.analyzeHand();

	this.startWait = getTimer();
	this.gotoAndStop("endDelay");
} // endOfTurn

ComputerPlayer.checkDelay = function () {
	if (getTimer() - this.startWait >= this.delayTime) {
		this.gotoAndStop("off");
		this.ComputerEndOfTurn();
	}
} // checkDelay

ComputerPlayer.ComputerEndOfTurn = function () {
	this.hide();
	
	this._endOfTurn = this.playerProto.endOfTurn;
	this._endOfTurn();
	delete this._endOfTurn;
} // ComputerEndOfTurn

delete ComputerPlayer;


