if (Object.Swim == null) {
	Object.Swim = {};
}

if (Object.Swim.Game == null) {
	Object.Swim.Game = {};
}

if (Object.Swim.Game.Deck == null) {
	Object.Swim.Game.Deck = {};
}

var Deck = Object.Swim.Game.Deck;

Deck.initDeck = function (cardArray) {
	// copy cardArray
	this.cards = [];
	this.discarded = [];
	var deckLength = cardArray.length;
	for (var i=0; i<deckLength; i++) {
		this.cards[i] = cardArray[i];
		this.cards[i].hide();
		// trace (this.cards[i]._name);
	}
	
	this.shuffle (this.cards);
	
}

Deck.shuffle = function (cardArray) {
	var shuffled = [];
	
	var card;
	
	while (cardArray.length > 0) {
		card = Math.floor (Math.random() * cardArray.length);		
		shuffled.push (cardArray[card]);
		cardArray.splice(card, 1);
	}

	var deckLength = shuffled.length;

	// move the shuffled elements back into the original array
	for (var i=0; i<deckLength; i++) {
		// trace (shuffled[i]);
		cardArray[i] = shuffled[i];
	}	
}

Deck.drawCard = function () {
	// returns first card from deck
	// reshuffles discarded stack if deck is empty
	
	if (this.cards.length < 1) {
		// grab the discarded stack
		this.cards = this.discarded;
		this.discarded = [];
		
		// shuffle
		this.shuffle(this.cards);
	
	}
	
	var firstCard = this.cards.shift();
	
	return firstCard;
}

Deck.drawCards = function (amount) {
	// returns amount cards in an array
	var cards = [];
	
	for (var i=0; i<amount; i++) {
		cards.push (this.drawCard() );
	}
	return cards;
}

Deck.discardCard = function (aCard) {
	// stores aCard in discarded stack
	this.discarded.push (aCard);
	aCard.hide();
}

Deck.discardCards = function (cardArray) {
	// stores all cards in cardArray in discarded stack
	var deckLength = cardArray.length;
	for (var i = 0; i< deckLength; i++ ) {
		this.discardCard ( cardArray [i] );
	}
}

// done defining deck
delete Deck;