// game_screens.as

if (object.Swim == null) {
	Object.Swim = {};
}

if (Object.Swim.GameScreens == null) {
	Object.Swim.GameScreens = {};
}

Object.Swim.GameScreens.initGameScreens = function (showMe, page) {
	findProto(Object.Swim.GameScreens).implement(Object.Screen.Generic);
	this.initScreenGeneric(showMe);
	
	this.pages = {
		title 					: "title"
		,chooseOpponent : "chooseOpponent" 
		,game 					: "game"
		,endRound 			: "endRound"			
		,endGame 				: "endGame"		
		,help 					: "help"	
	}
	
	this.helpBtn.implement (Object.Button);
	this.helpBtn.initButton ("active");
	
	this.activate();
	
	this.gotoPage (page);
}

Object.Swim.GameScreens.deactivate = function () {
	this.active = false;
}

Object.Swim.GameScreens.activate = function () {
	this.active = true;
}

Object.Swim.GameScreens.gotoPage = function (page, msg, rounds) {
	var myPage;
	
	if (page == null) {
		// no page being passed
		myPage = this.pages.title;
	} else {
		myPage = page;
	}
	if (myPage != this.currentPage) {
		this.gotoAndStop(myPage);
	
		if ( myPage == this.pages.title ) {
			this.screen.implement (Object.Screen.Title);
			this.screen.initScreenTitle(true);
		}
		else if ( myPage == this.pages.chooseOpponent ) {
			this.screen.implement (Object.Screen.ChooseOpponent);
			this.screen.initScreenChooseOpponent(true);
		}
		else if (myPage == this.pages.endGame || myPage == this.pages.endRound) {
			this.screen.implement (Object.Screen.End);
			this.screen.initScreenEnd(true);
			
			// store message and rounds (in case the screen is left for help)
			this.msg = msg;
			this.rounds = rounds;
			
			this.screen.showEndScreen (_parent, myPage, msg, rounds);
		}
		else if (mypage == this.pages.game) {
			this.screen.implement (Object.Screen.Game);
			this.screen.initScreenGame (true);
			
			_parent.showGame();
		}
		
		if (myPage == this.pages.help) {			
			this.screen.implement (Object.Screen.Help);
			this.screen.initScreenHelp(true);
			this.helpBtn.set ("hide");
		} else {
			this.helpBtn.set ("active");
		}
		
		// keep track of last page
		if (this.currentPage != null) {
			this.lastPage = this.currentPage;
		}
		
		// set current page
		this.currentPage = myPage;
	}
}

Object.Swim.GameScreens.initGame = function () {
	if (this.active) {		
		this.gotoPage (this.pages.chooseOpponent);
	}
}

Object.Swim.GameScreens.startGame = function () {
	if (this.active) {
		this.gotoPage ( this.pages.game );
		_parent.startGame();
	}
}

Object.Swim.GameScreens.gameComputer = function () {
	this.gotoPage ( this.pages.game );
	_parent.setOpponent("computer");
}

Object.Swim.GameScreens.gameTwoPlayers = function () {
	this.gotoPage ( this.pages.game );
	_parent.setOpponent("twoPlayers");
}

Object.Swim.GameScreens.resetGame = function () {
	if (this.active) {
		// trace ("screens reset");
		this.gotoPage (this.pages.title);
		_parent.resetGame();
	}
}

Object.Swim.GameScreens.buttonRelease = function (button) {
	if (this.active) {
		if (button == this.helpBtn) {
			this.gotoPage (this.pages.help);
			_parent.hideGame();
		}
	}
} // buttonRelease

Object.Swim.GameScreens.backPage = function () {
	if (this.lastPage == this.pages.endRound 
				|| this.lastPage == this.pages.endGame) {
		this.gotoPage (this.lastPage, this.msg, this.rounds);
	} else {
		this.gotoPage (this.lastPage);
	}
}